<?php

namespace App\Http\Controllers\Admin;

use App\Exports\UserExport;
use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\UserRequest;
use App\Services\Response\ResponseService;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\Models\User;
use App\Models\Module;
use Maatwebsite\Excel\Facades\Excel;
use Users_model;

class UserController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath = '/admin/users';
    /** View folder */
    private $viewDirectory = 'admin.users.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('users.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the users.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request)
    {
        $query = User::latest();
        if(\Auth::user()->role == 'super_admin')
        {
            $query->whereIn('role',['super_admin','admin','sub_admin']);
        }
        else
        {
            $query->whereIn('role',['admin','sub_admin']);
        }

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }

        if ($request->email) {
            $query->where('email', 'LIKE', '%'.$request->email.'%');
        }

        if ($request->role) {
            $query->where('role', strtolower($request->role) );
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }
        if($request->export)
        {
            $users= $query->cursor();
            return Excel::download(new UserExport($users), 'Admins.xlsx');
        }

        $users= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('users'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('users.store');
        $head = metaFields('users', 'add_new', getCurrentLocale()) ?? __('users.new');

        $modules= Module::where('deleted_at', null)->cursor();
        $user_modules= old('Modules',  []);

        return view( $this->viewDirectory.'form', compact('action', 'head', 'modules', 'user_modules') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param UserRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(UserRequest $request)
    {
        $data = $request->all();
        if(is_null($request->photo))
        {
            $data['photo'] = 'logo.png';
        }

        $data['password'] = bcrypt($request->password);

        $user= User::create($data);

        $user->modules()->sync($request->modules);


        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('users.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  User  $user
     * @return View
     */
    public function edit(User $user): View
    {
        $action= route('users.update', $user->id);
        $head = metaFields('users', 'edit', getCurrentLocale()) ?? __('users.edit');

        $user_modules= old('Modules',  $user->modules()->pluck('Modules.id')->toArray() ?? []);

        $modules= Module::cursor();

        return view( $this->viewDirectory.'form', compact('user', 'action', 'head', 'modules', 'user_modules' ) );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  UserRequest  $request
     * @param  User  $user
     * @return RedirectResponse|Redirector
     */
    public function update(UserRequest $request, User $user)
    {
        // dd($request->all());
        $data= $request->all();

        if(is_null($request->photo))
        {
            $data['photo'] = 'logo.png';
        }

        if($data['password']) {
            $data['password']= bcrypt( $data['password'] );
        } else {
            unset($data['password']);
        }
        $user->update($data);

        if ($request->modules){
            $user->modules()->sync($request->modules);
        }


        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('users.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = User::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            User::onlyTrashed()->whereIn('id', $ids)->where('role', '!=', 'admin')->forceDelete();
        } else {
            User::whereIn('id', $ids)->where('role', '!=', 'admin')->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = User::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = User::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.saveDone')]);
    }
}
